<?php
/**
* BooksLibrary Toolbar Menu HTML
* @ Version: 1.0
* @ Autor : Gerd Saurer
* @ URL: booklibrary.mamboforge.net
* @ MAIL: goertsch@users.mamboforge.net
* @ Copyright (C) 2004 Gerd Saurer
* @ Released under GNU/GPL License: http://www.gnu.org/copyleft/gpl.html
**/

// ensure this file is being included by a parent file
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

// *** Get language files
global $mosConfig_absolute_path, $mosConfig_alang;

if (file_exists($mosConfig_absolute_path."/components/com_booklibrary/language/{$mosConfig_alang}.php" )) {
	include_once($mosConfig_absolute_path."/components/com_booklibrary/language/{$mosConfig_alang}.php" );
} else {
	include_once($mosConfig_absolute_path."/components/com_booklibrary/language/english.php" );
}

class menubooklibrary {

	function MENU_NEW() {
		mosMenuBar::startTable();
		mosMenuBar::save();
		mosMenuBar::cancel();
		//mosMenuBar::help(./components/com_booklibrary/help/1.html);
		mosMenuBar::spacer();				
		mosMenuBar::endTable();
	}

	function MENU_EDIT() {
		mosMenuBar::startTable();
		mosMenuBar::save();
		mosMenuBar::cancel();
		//mosMenuBar::help();
		mosMenuBar::spacer();		
		mosMenuBar::endTable();
	}

	function MENU_CANCEL() {
		mosMenuBar::startTable();
		mosMenuBar::cancel();
		//mosMenuBar::help();
		mosMenuBar::spacer();		
		mosMenuBar::endTable();
	}

	function MENU_CONFIG() {
		mosMenuBar::startTable();
		mosMenuBar::custom("config_save", "save.png", "save_f2.png", _BOOKLIBRARY_TOOLBAR_ADMIN_SAVE, false);
		mosMenuBar::cancel();
		//mosMenuBar::help();
		mosMenuBar::spacer();		
		mosMenuBar::endTable();
	}
	
	function MENU_DEFAULT() {
		mosMenuBar::startTable();
		mosMenuBar::publishList();
		mosMenuBar::unpublishList();
		mosMenuBar::spacer();
		mosMenuBar::custom("refetchInfos", "../components/com_booklibrary/images/refetchInfos.png", "../components/com_booklibrary/images/refetchInfos_f2.png", _BOOKLIBRARY_TOOLBAR_ADMIN_REFRESH);		
		mosMenuBar::custom("lend", "../components/com_booklibrary/images/lend.png", "../components/com_booklibrary/images/lend_f2.png", _BOOKLIBRARY_TOOLBAR_ADMIN_LEND);		
		mosMenuBar::custom("lend_return", "../components/com_booklibrary/images/lend_return.png", "../components/com_booklibrary/images/lend_return_f2.png", _BOOKLIBRARY_TOOLBAR_ADMIN_RETURN);		
		mosMenuBar::addNew();
		//mosMenuBar::editList();
		mosMenuBar::deleteList();
		//mosMenuBar::help(./components/com_booklibrary/help/1.html);
		mosMenuBar::spacer();		
		mosMenuBar::endTable();
	}

	function MENU_LEND() {
		mosMenuBar::startTable();
		mosMenuBar::custom("lend", "../components/com_booklibrary/images/lend.png", "../components/com_booklibrary/images/lend_f2.png", _BOOKLIBRARY_TOOLBAR_ADMIN_LEND);		
		mosMenuBar::cancel();
		//mosMenuBar::help(./components/com_booklibrary/help/1.html);
		mosMenuBar::spacer();		
		mosMenuBar::endTable();
	}

	function MENU_LENDREQUESTS() {
		mosMenuBar::startTable();
		mosMenuBar::custom("accept_lend_requests", "../components/com_booklibrary/images/accept.png", "../components/com_booklibrary/images/accept_f2.png", _BOOKLIBRARY_TOOLBAR_ADMIN_ACCEPT);		
		mosMenuBar::custom("decline_lend_requests", "../components/com_booklibrary/images/decline.png", "../components/com_booklibrary/images/decline_f2.png", _BOOKLIBRARY_TOOLBAR_ADMIN_DECLIN);
		mosMenuBar::cancel();
		//mosMenuBar::help(./components/com_booklibrary/help/1.html);
		mosMenuBar::spacer();		
		mosMenuBar::endTable();
	}
	
	function MENU_LEND_RETURN() {
		mosMenuBar::startTable();
		mosMenuBar::custom("lend_return", "../components/com_booklibrary/images/lend_return.png", "../components/com_booklibrary/images/lend_return_f2.png", _BOOKLIBRARY_TOOLBAR_ADMIN_RETURN);		
		mosMenuBar::cancel();
		//mosMenuBar::help(./components/com_booklibrary/help/1.html);
		mosMenuBar::spacer();		
		mosMenuBar::endTable();
	}
	
	function MENU_REFETCH_INFOS(){
		mosMenuBar::startTable();
		mosMenuBar::custom("refetchInfos", "../components/com_booklibrary/images/refetchInfos.png", "../components/com_booklibrary/images/refetchInfos_f2.png", _BOOKLIBRARY_TOOLBAR_ADMIN_REFRESH);		
		mosMenuBar::cancel();		
		//mosMenuBar::help(./components/com_booklibrary/help/1.html);
		mosMenuBar::spacer();
		mosMenuBar::endTable();	
	}
	
	function MENU_IMPORT_EXPORT(){
		mosMenuBar::startTable();
		mosMenuBar::custom("import", "../components/com_booklibrary/images/import.png", "../components/com_booklibrary/images/import_f2.png", _BOOKLIBRARY_TOOLBAR_ADMIN_IMPORT, false);
		mosMenuBar::custom("export", "../components/com_booklibrary/images/export.png", "../components/com_booklibrary/images/export_f2.png", _BOOKLIBRARY_TOOLBAR_ADMIN_EXPORT, false);
		mosMenuBar::cancel();		
		//mosMenuBar::help(./components/com_booklibrary/help/1.html);
		mosMenuBar::spacer();
		mosMenuBar::endTable();	
	}
	function MENU_ABOUT(){
		mosMenuBar::startTable();
		mosMenuBar::back();		
		mosMenuBar::endTable();	
	}
	
}
?>